# $Revision: 1.13 $, $Date: 2010/12/17 23:19:21 $
# TODO:
# - java.lang.NullPointerException
#   at gnu.classpath.tools.doclets.htmldoclet.HtmlDoclet.printClassPage(HtmlDoclet.java:2057)
#   at gnu.classpath.tools.doclets.htmldoclet.HtmlDoclet.run(HtmlDoclet.java:3153)
#   at gnu.classpath.tools.doclets.AbstractDoclet.startInstance(AbstractDoclet.java:200)
#   at gnu.classpath.tools.doclets.AbstractDoclet.start(AbstractDoclet.java:131)
#   at java.lang.reflect.Method.invoke(libgcj.so.9)
#   at gnu.classpath.tools.gjdoc.Main.startDoclet(Main.java:629)
#   at gnu.classpath.tools.gjdoc.Main.start(Main.java:1159)
#   at gnu.classpath.tools.gjdoc.Main.main(Main.java:883)

%bcond_without  javadoc         # don't build javadoc
%bcond_with	java_sun	# build with java-sun
%include	/usr/lib/rpm/macros.java
%define 	srcname	lucene
%define		contrib_ver	2.4

Summary:	Text search engine library in Java
Name:		java-%{srcname}
Version:	2.4.1
Release:	6
License:	Apache v2.0
Group:		Libraries/Java
Source0:	http://www.apache.org/dist/lucene/java/lucene-%{version}-src.tar.gz
# Source0-md5:	ad46595439240e10387fcbf7647705db
Source1:	je-4.1.6.jar
# Source1-md5:	b7cd75e409267b903c3cb8e1da1856e9
Patch0:		%{name}-test.patch
Patch1:		%{name}-je_jar.patch
URL:		http://lucene.apache.org/
BuildRequires:	ant
BuildRequires:	db-java
BuildRequires:	java-commons-digester
BuildRequires:	jdk
BuildRequires:	jpackage-utils
BuildRequires:	rpm-javaprov
BuildRequires:	rpmbuild(macros) >= 1.300
Requires:	jpackage-utils
BuildArch:	noarch
BuildRoot:	%{tmpdir}/%{name}-%{version}-root-%(id -u -n)

%description
Apache Lucene is a high-performance, full-featured text search engine
library written entirely in Java. It is a technology suitable for
nearly any application that requires full-text search, especially
cross-platform.

%package contrib
Summary:	Contrib packages for lucene
Group:		Libraries/Java
Requires:	%{name} = %{version}

%description contrib
Contrib packages for lucene.

%package javadoc
Summary:	Online manual for lucene
Summary(pl.UTF-8):	Dokumentacja online do lucene
Group:		Documentation
Requires:	jpackage-utils

%description javadoc
Documentation for lucene.

%description javadoc -l pl.UTF-8
Dokumentacja do lucene.

%description javadoc -l fr.UTF-8
Javadoc pour lucene.

%prep
%setup -q -n %{srcname}-%{version}
%patch0 -p1
%patch1 -p1

# FIXME: move je.jar to separate spec and use it via CLASSPATH
mkdir contrib/db/bdb-je/lib
cp %{SOURCE1} contrib/db/bdb-je/lib/je.jar

%build
CLASSPATH=$(build-classpath commons-digester db)

export LC_ALL=en_US

install -d build
%ant -Dbuild.sysclasspath=only

# Build contrib packages too
cd contrib
CONTRIB_PACKAGES="analyzers benchmark db highlighter instantiated lucli memory miscellaneous queries regex similarity snowball spellchecker surround swing wikipedia wordnet xml-query-parser"
for i in $CONTRIB_PACKAGES
do
cd $i
install -d build
%ant
cd -
done

cd ..
%if %{with javadoc}
%javadoc -d apidocs \
	%{?with_java_sun:org.apache.lucene} \
	$(find src/java/org/apache/lucene -name '*.java')
%endif

%install
rm -rf $RPM_BUILD_ROOT
install -d $RPM_BUILD_ROOT%{_javadir}

cp -a build/%{srcname}-core-2.4.jar $RPM_BUILD_ROOT%{_javadir}/%{srcname}-core-%{version}.jar
ln -s %{srcname}-core-%{version}.jar $RPM_BUILD_ROOT%{_javadir}/%{srcname}-core.jar
ln -s %{srcname}-core-%{version}.jar $RPM_BUILD_ROOT%{_javadir}/%{srcname}.jar

# Contrib packages
CONTRIB_PACKAGES="analyzers benchmark highlighter instantiated lucli memory misc queries regex similarity snowball spellchecker surround swing wikipedia wordnet xml-query-parser"
for i in $CONTRIB_PACKAGES
do
cp -a build/contrib/$i/%{srcname}-$i-%{contrib_ver}.jar $RPM_BUILD_ROOT%{_javadir}/%{srcname}-$i-%{contrib_ver}.jar
ln -s %{srcname}-$i-%{contrib_ver}.jar $RPM_BUILD_ROOT%{_javadir}/%{srcname}-$i.jar
%jar -cf %{srcname}-$i-%{contrib_ver}.jar -C build/contrib/$i/classes/java .
done
cp -a build/contrib/db/bdb/%{srcname}-bdb-%{contrib_ver}.jar $RPM_BUILD_ROOT%{_javadir}/%{srcname}-bdb-%{contrib_ver}.jar
ln -s %{srcname}-bdb-%{contrib_ver}.jar $RPM_BUILD_ROOT%{_javadir}/%{srcname}-bdb.jar
cp -a build/contrib/db/bdb-je/%{srcname}-bdb-je-%{contrib_ver}.jar $RPM_BUILD_ROOT%{_javadir}/%{srcname}-bdb-je-%{contrib_ver}.jar
ln -s %{srcname}-bdb-je-%{contrib_ver}.jar $RPM_BUILD_ROOT%{_javadir}/%{srcname}-bdb-je.jar

# javadoc
%if %{with javadoc}
install -d $RPM_BUILD_ROOT%{_javadocdir}/%{srcname}-%{version}
cp -a apidocs/* $RPM_BUILD_ROOT%{_javadocdir}/%{srcname}-%{version}
ln -s %{srcname}-%{version} $RPM_BUILD_ROOT%{_javadocdir}/%{srcname} # ghost symlink
%endif

%clean
rm -rf $RPM_BUILD_ROOT

%post javadoc
ln -nfs %{srcname}-%{version} %{_javadocdir}/%{srcname}

%files
%defattr(644,root,root,755)
%{_javadir}/%{srcname}-core-%{version}.jar
%{_javadir}/%{srcname}-core.jar
%{_javadir}/%{srcname}.jar

%if %{with javadoc}
%files javadoc
%defattr(644,root,root,755)
%{_javadocdir}/%{srcname}-%{version}
%ghost %{_javadocdir}/%{srcname}
%endif

%files contrib
%defattr(644,root,root,755)
%{_javadir}/%{srcname}-analyzers-%{contrib_ver}.jar
%{_javadir}/%{srcname}-analyzers.jar
%{_javadir}/%{srcname}-bdb-%{contrib_ver}.jar
%{_javadir}/%{srcname}-bdb-je-%{contrib_ver}.jar
%{_javadir}/%{srcname}-bdb-je.jar
%{_javadir}/%{srcname}-bdb.jar
%{_javadir}/%{srcname}-benchmark-%{contrib_ver}.jar
%{_javadir}/%{srcname}-benchmark.jar
%{_javadir}/%{srcname}-highlighter-%{contrib_ver}.jar
%{_javadir}/%{srcname}-highlighter.jar
%{_javadir}/%{srcname}-instantiated-%{contrib_ver}.jar
%{_javadir}/%{srcname}-instantiated.jar
%{_javadir}/%{srcname}-lucli-%{contrib_ver}.jar
%{_javadir}/%{srcname}-lucli.jar
%{_javadir}/%{srcname}-memory-%{contrib_ver}.jar
%{_javadir}/%{srcname}-memory.jar
%{_javadir}/%{srcname}-misc-%{contrib_ver}.jar
%{_javadir}/%{srcname}-misc.jar
%{_javadir}/%{srcname}-queries-%{contrib_ver}.jar
%{_javadir}/%{srcname}-queries.jar
%{_javadir}/%{srcname}-regex-%{contrib_ver}.jar
%{_javadir}/%{srcname}-regex.jar
%{_javadir}/%{srcname}-similarity-%{contrib_ver}.jar
%{_javadir}/%{srcname}-similarity.jar
%{_javadir}/%{srcname}-snowball-%{contrib_ver}.jar
%{_javadir}/%{srcname}-snowball.jar
%{_javadir}/%{srcname}-spellchecker-%{contrib_ver}.jar
%{_javadir}/%{srcname}-spellchecker.jar
%{_javadir}/%{srcname}-surround-%{contrib_ver}.jar
%{_javadir}/%{srcname}-surround.jar
%{_javadir}/%{srcname}-swing-%{contrib_ver}.jar
%{_javadir}/%{srcname}-swing.jar
%{_javadir}/%{srcname}-wikipedia-%{contrib_ver}.jar
%{_javadir}/%{srcname}-wikipedia.jar
%{_javadir}/%{srcname}-wordnet-%{contrib_ver}.jar
%{_javadir}/%{srcname}-wordnet.jar
%{_javadir}/%{srcname}-xml-query-parser-%{contrib_ver}.jar
%{_javadir}/%{srcname}-xml-query-parser.jar

%define date	%(echo `LC_ALL="C" date +"%a %b %d %Y"`)
%changelog
* %{date} PLD Team <feedback@pld-linux.org>
All persons listed below can be reached at <cvs_login>@pld-linux.org

$Log: java-lucene.spec,v $
Revision 1.13  2010/12/17 23:19:21  megabajt
- don't get jars from the Internet (db.jar, je.jar)
- install lucene.jar with fully generated MANIFEST.MF (as expected by libreoffice)
- release 6

Revision 1.12  2010/04/23 00:03:25  pawelz
- Don't force specific jdk.

Revision 1.11  2009/03/30 05:39:47  pawelz
- G: Libraries/Java
- unified apache download link

Revision 1.10  2009/03/29 17:28:27  paszczus
- -contrib Requires: %name = %version

Revision 1.9  2009/03/29 16:33:26  pawelz
- BR: ant

Revision 1.8  2009/03/29 16:21:48  paszczus
- proper bcond for Titanium
- package contrib files to -contrib subpackage
- rel 5

Revision 1.7  2009/03/29 08:15:49  paszczus
- build contrib packages too; rel 4

Revision 1.6  2009/03/28 23:04:51  pawelz
- correct paths in jar
- rel 3

Revision 1.5  2009/03/28 22:13:06  pawelz
- source is UTF, so set LC_ALL for javadoc
- TODO (exception while generating doc with gjdoc)

Revision 1.4  2009/03/27 12:23:34  paszczus
- Patch0 seems to be good, so rel 2

Revision 1.3  2009/03/27 11:09:51  paszczus
- added Patch0, just for tests

Revision 1.2  2009/03/27 10:36:54  paszczus
- rel 1

Revision 1.1  2009/03/27 10:18:44  paszczus
- initial
